---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: polybanking
  labels:
    name: polybanking
    owner: agepinfo
spec:
  replicas: 1
  selector:
    matchLabels:
      app: polybanking
      owner: agepinfo
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxSurge: 2
      maxUnavailable: 0
  template:
    metadata:
      labels:
        app: polybanking
        owner: agepinfo
    spec:
      imagePullSecrets:
        - name: gitlab-kubernetes
        - name: gitlab-dckreg
      containers:
        - name: polybanking
          image: registry.gitlab.com/agepoly/it/infra/kubernetes/polybanking:665b6dd2
          ports:
            - containerPort: 80
          env:
            - name: APP_CONFIG
              value: "/etc/polybanking/config.yml"
            - name: HOST
              value: "polybanking.staging.agepoly.ch"
          volumeMounts:
            - {"subPath":"config.yml","name":"polybanking-secrets--etc-polybanking-config-yml","mountPath":"/etc/polybanking/config.yml"}
          livenessProbe:
            failureThreshold: 2
            httpGet:
              path: /
              port: 80
              scheme: HTTP
              httpHeaders:
                - name: Host
                  value: polybanking.staging.agepoly.ch
            initialDelaySeconds: 300
            periodSeconds: 300
            timeoutSeconds: 10
          readinessProbe:
            failureThreshold: 1
            httpGet:
              path: /
              port: 80
              scheme: HTTP
              httpHeaders:
                - name: Host
                  value: polybanking.staging.agepoly.ch
            initialDelaySeconds: 5
            periodSeconds: 150
            timeoutSeconds: 10
          startupProbe:
            failureThreshold: 30
            httpGet:
              path: /
              port: 80
              scheme: HTTP
              httpHeaders:
                - name: Host
                  value: polybanking.staging.agepoly.ch
            initialDelaySeconds: 5
            periodSeconds: 10
            timeoutSeconds: 10
      nodeSelector:
        storage_node: "true"
      volumes:
        - {"secret":{"defaultMode":292,"items":[{"path":"config.yml","key":"-etc-polybanking-config-yml"}],"secretName":"polybanking-file-secrets"},"name":"polybanking-secrets--etc-polybanking-config-yml"}

---
apiVersion: v1
kind: Service
metadata:
  name: polybanking
  labels:
    name: polybanking
    owner: agepinfo
spec:
  ports:
    - port: 80
      targetPort: 80
      protocol: TCP
      name: http
  selector:
      app: polybanking
      owner: agepinfo
  type: ClusterIP

---
apiVersion: traefik.containo.us/v1alpha1
kind: IngressRoute
metadata:
  name: polybanking-main-domain
  labels:
    name: polybanking
    owner: agepinfo
spec:
  entryPoints:
    - websecure
  tls:
    secretName: staging.agepoly.ch-wildcard-ssl
  routes:
    - match: Host(`polybanking.staging.agepoly.ch`)
      kind: Rule
      services:
        - name: polybanking
          port: 80
          sticky:
            cookie:
              httpOnly: true
              name: lb
              secure: true
              sameSite: none
          strategy: RoundRobin

